// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------

// BlobPatternDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "BlobPattern.h"
#include "BlobPatternDlg.h"
#include "BlobResultDlg.h"
#include "Display.h"
#include "LicenceDlg.h"
#include "ConfFileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBlobPatternDlg _CAO

CBlobPatternDlg::CBlobPatternDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBlobPatternDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBlobPatternDlg)
	m_color = -1;
	m_searchmode = -1;
	m_precision = -1;
	m_binlevel = 128;
	m_minsize = 5;
	m_maxsize = 245760;
	m_arrange = 0;
	m_blobwndtouch = FALSE;
	m_result = _T("");
	m_angle = 0;
	m_condition = 5;
	m_threshold = 60;
	m_middlethreshold = 50;
	m_searchnum = 1;
	m_gswndtouch = FALSE;
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_blnVideoOpened = false;
	m_disp = NULL;
}

void CBlobPatternDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBlobPatternDlg)
	DDX_CBIndex(pDX, IDC_COLOR, m_color);
	DDX_CBIndex(pDX, IDC_SEARCHMODE, m_searchmode);
	DDX_CBIndex(pDX, IDC_PRECISION, m_precision);
	DDX_Text(pDX, IDC_BINLEVEL, m_binlevel);
	DDV_MinMaxInt(pDX, m_binlevel, 0, 255);
	DDX_Text(pDX, IDC_MINSIZE, m_minsize);
	DDX_Text(pDX, IDC_MAXSIZE, m_maxsize);
	DDX_Radio(pDX, IDC_ARRANGE0, m_arrange);
	DDX_Check(pDX, IDC_BLOBWNDTOUCH, m_blobwndtouch);
	DDX_Text(pDX, IDC_RESULT, m_result);
	DDX_Text(pDX, IDC_ANGLE, m_angle);
	DDX_Text(pDX, IDC_CONDITION, m_condition);
	DDV_MinMaxInt(pDX, m_condition, 1, 9);
	DDX_Text(pDX, IDC_THRESHOLD, m_threshold);
	DDV_MinMaxInt(pDX, m_threshold, 10, 99);
	DDX_Text(pDX, IDC_MIDDLETHRESHOLD, m_middlethreshold);
	DDV_MinMaxInt(pDX, m_middlethreshold, 10, 99);
	DDX_Text(pDX, IDC_SEARCHNUM, m_searchnum);
	DDV_MinMaxInt(pDX, m_searchnum, 1, 9999999);
	DDX_Check(pDX, IDC_GSWNDTOUCH, m_gswndtouch);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBlobPatternDlg, CDialog)
	//{{AFX_MSG_MAP(CBlobPatternDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	ON_BN_CLICKED(IDC_BLOBEXEREGION, OnBlobexeregion)
	ON_BN_CLICKED(IDC_DISPBIN, OnDispbin)
	ON_BN_CLICKED(IDC_LOADIMAGE, OnLoadimage)
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveimage)
	ON_BN_CLICKED(IDC_SETPATTERN, OnSetpattern)
	ON_BN_CLICKED(IDC_DISPPATTERN, OnDisppattern)
	ON_BN_CLICKED(IDC_SETPATTERNMASK, OnSetpatternmask)
	ON_BN_CLICKED(IDC_LOADPATTERN, OnLoadpattern)
	ON_BN_CLICKED(IDC_SAVEPATTERN, OnSavepattern)
	ON_BN_CLICKED(IDC_EXECUTE, OnExecute)
	ON_BN_CLICKED(IDC_GSEXEREGION, OnGsexeregion)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBlobPatternDlg bZ[W nh

BOOL CBlobPatternDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	/* -------------------------------------------------------------------------------- */
	// FvxSample 
	CLicenceDlg dlg;
	CConfFileDlg fdlg;

	// CZXʂ̕\
	if (dlg.DoModal() == IDOK){

		//Ӂ
		// ߂COM̏sƂYȂłB
		CoInitialize( NULL );
		long err_no ;

		// eFvxRg[̃CX^X𐶐܂B
		// w肷NXԈႦȂ悤ӂĂB
		m_FvxImageGray.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxImageBin.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxImageTemp.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) ); 
		m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) ); 
		m_FvxPerformanceCounter.CreateInstance( __uuidof( FvxPerformanceCounter ) ); 
		m_FvxChangeImage.CreateInstance( __uuidof( FvxChangeImage ) ); 
		m_FvxBlob.CreateInstance( __uuidof( FvxBlob ) ); 
		m_FvxROI.CreateInstance( __uuidof( FvxROI ) ); 
		m_FvxCorrelation.CreateInstance( __uuidof( FvxCorrelation ) ); 
		m_FvxPattern.CreateInstance( __uuidof( FvxPattern ) ); 
		m_BlobExeRegion.CreateInstance( __uuidof( FvRectangle ) ); 
		m_GSExeRegion.CreateInstance( __uuidof( FvRectangle ) ); 

		// J荞ݖ
		GetDlgItem( IDC_GRAB )->EnableWindow( FALSE );

		// fBXvC
	    m_disp = new CDisplay();
		m_disp->Create( IDD_DISPLAY , GetDesktopWindow() );
		m_disp->ShowWindow( SW_HIDE );

		// fBXvC̏
		m_disp->m_FvxDisplayEx->CreateDisplay( 1 , 0 );

		// ͈͂̏lݒi摜̑Oʂɐݒj
		m_GSExeRegion->Putxs( -1 );
		m_GSExeRegion->Putxe( -1 );
		m_GSExeRegion->Putys( -1 );
		m_GSExeRegion->Putye( -1 );

		m_BlobExeRegion->Putxs( -1 );
		m_BlobExeRegion->Putxe( -1 );
		m_BlobExeRegion->Putys( -1 );
		m_BlobExeRegion->Putye( -1 );

		m_disp->m_FvxDisplayEx->PutPenColor( 0xFF0000 );
		m_disp->m_FvxDisplayEx->DrawData( 0, m_GSExeRegion );
		m_disp->m_FvxDisplayEx->PutPenColor( 0x0000FF );
		m_disp->m_FvxDisplayEx->DrawData( 0, m_BlobExeRegion );

		// Rg[ނ̏
		CComboBox*    pcmb;
		pcmb = ( CComboBox* )GetDlgItem( IDC_COLOR );
		pcmb->AddString( "BLACK" );
		pcmb->AddString( "WHITE" );
		m_color = 0;
		
		pcmb = ( CComboBox* )GetDlgItem( IDC_SEARCHMODE );
		pcmb->AddString( "ʏ̃p^[" );
		pcmb->AddString( "̃p^[" );
		pcmb->AddString( "̃p^[" );
		pcmb->AddString( "sp^[" );
		m_searchmode = 0 ;

		pcmb = ( CComboBox* )GetDlgItem( IDC_PRECISION );
		pcmb->AddString( "ʏ퐸x" );
		pcmb->AddString( "x" );
		pcmb->AddString( "x" );
		m_precision = 0 ;
		
		m_arrange = 0 ;
		UpdateData(FALSE); 
		
		// rfIݒt@C̑I
		fdlg.DoModal();

		if ( fdlg.m_check == FALSE ) {

			// rfIݒt@CR|[lgɐݒ
 			m_FvxVideo->PutVideoConfFile( _bstr_t( fdlg.m_conffile ));

			// rfIfoCXI[v
			try {

				m_FvxVideo->OpenDevice();

			} catch( _com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfIfoCX̃I[vɎs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
			}

			// VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
			// ̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
			// {vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
			// g̃Lv`{[hɍ킹ĕύXĂB
			::Sleep( 350 );

			// GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
            // 炩ChangeImageSize\bhɂImagẽTCYύXĂ
            //i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
			m_FvxVideo->ChangeImageSize( m_FvxImageGray );

			try	{

				// 捞
				m_FvxVideo->GrabSync( m_FvxImageGray );

			} catch(_com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfI̎捞Ɏs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B

			}

			// J荞ݗL
			GetDlgItem( IDC_GRAB )->EnableWindow( TRUE );
			// rfIfoCX̏ԂL
			m_blnVideoOpened = true;

		}

		// 摜̕\
		m_disp->m_FvxDisplayEx->DrawImage( m_FvxImageGray );

	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}
	UpdateData(FALSE); 
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CBlobPatternDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CBlobPatternDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		// fBXvC\
		m_disp->ShowWindow( SW_SHOW );
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CBlobPatternDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CBlobPatternDlg::OnGrab() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    
	// 摜t@Cǂݍ݂ɂāA摜TCY
    // ύXĂ\邽߁AChangeImageSizes܂B
    // 摜TCYύX\ꍇ́AɈxsΖL܂B
    m_FvxVideo->ChangeImageSize( m_FvxImageGray );
    
    m_FvxVideo->GrabSync( m_FvxImageGray );    // 捞
    m_disp->m_FvxDisplayEx->DrawImage( m_FvxImageGray );
	
}

void CBlobPatternDlg::OnBlobexeregion() 
{


	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    long lngOK = 0;
    double dblTemp = 0;
    
    m_FvxROI->SetRectangle( m_BlobExeRegion );
    
    // FvxROIgď͈͑I_CAOo܂
    m_FvxROI->PutUsePoint( FALSE );
    m_FvxROI->MakeROIDialog( m_FvxImageGray, &lngOK );
    
    if (( lngOK == 1 ) && ( m_FvxROI->GetCheckRectangle() == 1 )) {

        m_FvxROI->GetRectangle( m_BlobExeRegion );
        
        // n_ƏI_tɂȂĂȂ`FbN܂
        // FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
        // tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
        if ( m_BlobExeRegion->Getxe()  < m_BlobExeRegion->Getxs()) {
            dblTemp = m_BlobExeRegion->Getxs();
            m_BlobExeRegion->Putxs( m_BlobExeRegion->Getxe());
            m_BlobExeRegion->Putxe( dblTemp );
		}
		if ( m_BlobExeRegion->Getye() < m_BlobExeRegion->Getys()) {
            dblTemp = m_BlobExeRegion->Getys();
            m_BlobExeRegion->Putys(m_BlobExeRegion->Getye());
            m_BlobExeRegion->Putye( dblTemp );
		}
	}
		
	DrawExeRegion();
	
}

void CBlobPatternDlg::DrawExeRegion()
{
    
	m_disp->m_FvxDisplayEx->ClearOverlay( -1 );
	m_disp->m_FvxDisplayEx->PutPenColor( 0xFF0000 );
	m_disp->m_FvxDisplayEx->DrawData( 0, m_GSExeRegion );
	m_disp->m_FvxDisplayEx->PutPenColor( 0x0000FF );
	m_disp->m_FvxDisplayEx->DrawData( 0, m_BlobExeRegion );

}

// Ql臒lύX
void CBlobPatternDlg::OnDispbin() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if ( !UpdateData( TRUE ) ) return;
	
	long BinLevel = 0;
    BinLevel = m_binlevel;
    
    if ( BinLevel < 0 ) BinLevel = 0;
    if ( BinLevel > 255 ) BinLevel = 255;
    
    m_FvxChangeImage->FixedLevel( m_FvxImageGray , m_FvxImageBin , BinLevel );
    m_disp->m_FvxDisplayEx->DrawImage( m_FvxImageBin );
}

void CBlobPatternDlg::OnLoadimage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData( TRUE );

	long BinLevel = 0;

	BinLevel = m_binlevel;
    
    if ( BinLevel < 0 ) BinLevel = 0 ;
    if ( BinLevel > 255 ) BinLevel = 255 ;
	
	// R_CAONX̐
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){
		m_FvxFileAccess->PutFilePath( _bstr_t( cFileDlg.GetPathName() ) );

		try {
		
			m_FvxFileAccess->LoadBitmap( m_FvxImageGray );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("Ǎ݂Ɏs܂Berr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}

		// 摜^Cv`FbN
		if (( m_FvxImageGray->GetImageType ()!=imageGray ) || ( m_FvxImageTemp->GetBitPerPixel()!=8 )) {

			MessageBox("OC摜ł͂܂","G[", MB_ICONWARNING | MB_OK);

            m_FvxImageTemp->PutBitPerPixel( 8 );
            m_FvxImageTemp->PutImageType( imageGray );
            m_FvxImageTemp->PutImageWidth( 512 );
            m_FvxImageTemp->PutImageHeight( 480 );

		}

        m_disp->m_FvxDisplayEx->DrawImage( m_FvxImageGray );

	}
}

void CBlobPatternDlg::OnSaveimage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath ( _bstr_t( cFileDlg.GetPathName() ));

		try {
		
			m_FvxFileAccess->SaveBitmap( m_FvxImageGray );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
}

void CBlobPatternDlg::OnSetpattern() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if ( !UpdateData( TRUE ) ) return;

    // ʏ
    m_disp->m_FvxDisplayEx->ClearOverlay( -1 );
    m_disp->m_FvxDisplayEx->DrawImage( m_FvxImageGray );
    
    // Ql
    if ( m_binlevel < 0 ) m_binlevel = 0;
    if ( m_binlevel > 255 ) m_binlevel = 255;
    
    m_FvxChangeImage->FixedLevel( m_FvxImageGray, m_FvxImageBin, m_binlevel );
 
    // ʐϒl`FbN
    if ( m_minsize < 1 ) {
		MessageBox("ŏʐϒl͂Pȏ̐lݒ肵Ă","p[^G[", MB_ICONWARNING | MB_OK);
		return;
	}
    if ( m_minsize >= m_maxsize ) {
		MessageBox("ŏʐϒlőʐϒlƂȂ悤ݒ肵Ă","p[^G[", MB_ICONWARNING | MB_OK);
		return;
	}
			
    // őEŏʐϐݒ
    m_FvxBlob->PutMinSize( m_minsize );
    m_FvxBlob->PutMaxSize( m_maxsize );
    
    // ]p
    if ( ( m_angle < -180 ) || ( m_angle > 180 ) ) {
		MessageBox("]p -180.0`180.0 ͈̔͂œ͂Ă","p[^G[", MB_ICONWARNING | MB_OK);
		return;
	}
	m_FvxBlob->Putangle( m_angle );
    
    // ΏېFݒ
	m_FvxBlob->PutColor(( enum COLOR_TYPE ) m_color ); 
 
    // xOiojݒ
	m_FvxBlob->PutArrange( ( enum ARRANGE_TYPE ) m_arrange );

    // ͈͐ڐG
    if ( m_blobwndtouch == TRUE ) m_FvxBlob->PutWindowTouch( ON );	
	else m_FvxBlob->PutWindowTouch( OFF );
				
    // ͈͐ݒ
    m_FvxBlob->SetInspectArea( m_BlobExeRegion );
    
	long lngCount = 0;
	long lngErr = 0;
	double dblTime = 0;
	CString cStr;

	try {
		
		// Qlvs
		m_FvxPerformanceCounter->StartCount();
		m_FvxBlob->Execute( m_FvxImageBin , &lngCount );
		m_FvxPerformanceCounter->StopCount( &dblTime ); // ԑI
		m_FvxBlob->GetErrReport( &lngErr );

	} catch(_com_error ) {

		// G[oĂ邩mF	
		// KGetErrReport\bhgăG[ԍ擾Ă
		m_FvxBlob->GetErrReport( &lngErr );
		cStr.Format("err_no = %d", lngErr );
		MessageBox(cStr, "G[" , MB_ICONWARNING | MB_OK );
		return ;
	}

	if (lngErr==0) {
	
		m_result.Format("%fms", dblTime );
		UpdateData( FALSE );

		// ʉʕ\
		CBlobResultDlg rdlg;

		// CZXʂ̕\
		rdlg.m_lngMaxBlobNo = lngCount - 1;
		rdlg.m_parent = this;
		rdlg.DoModal();

	}else{

		cStr.Format("err_no = %d", lngErr );
		MessageBox(cStr, "G[" , MB_ICONWARNING | MB_OK );
		return;
	}
    
	DrawExeRegion();

}

void CBlobPatternDlg::OnDisppattern() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// p^[̕\
    m_FvxPattern->Disp( -1, -1);
	
}

void CBlobPatternDlg::OnSetpatternmask() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// p^[̃}XNݒ
    m_FvxPattern->DefMask( -1, -1 );
	
}

void CBlobPatternDlg::OnLoadpattern() 
{

	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    // p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
    //  "pat"gp邱Ƃ𐄏܂
	// R_CAONX̐
	char szFilters[]="pattern file(*.pat)|*.pat||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "pat", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		try {
		
			m_FvxPattern->PutLoadPattrenFileName( _bstr_t( cFileDlg.GetPathName() ));
			m_FvxPattern->Load();
			
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxPattern->GetErrReport( &lngErr );
			cStr.Format("p^[ǍݎsBerr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
}

void CBlobPatternDlg::OnSavepattern() 
{

	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
	// "pat"gp邱Ƃ𐄏܂
	char szFilters[]="bitmap file(*.pat)|*.pat||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "pat", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		try {

			m_FvxPattern->PutSavePattrenFileName (_bstr_t( cFileDlg.GetPathName() ));
			m_FvxPattern->Save();
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxPattern->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
}

void CBlobPatternDlg::OnExecute() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if ( !UpdateData( TRUE ) ) return;

    IFvSearchResultGroup2Ptr pSearchResultGroup( __uuidof( FvSearchResultGroup ));
	IFvPointPtr pPoint( __uuidof( FvPoint ));
    long lngCount = 0;
	double dblTime = 0;
    
    m_disp->m_FvxDisplayEx->ClearOverlay( -1 );
    m_disp->m_FvxDisplayEx->DrawImage( m_FvxImageGray );

    try{
	
		// p[^ݒ
		m_FvxCorrelation->SetInspectArea( m_GSExeRegion );							// ͈
		m_FvxCorrelation->PutSearchMode( ( enum SEARCH_MODE_TYPE ) m_searchmode );  // T[`[hiׂȂǂ̃p^[Ɏgpj
		m_FvxCorrelation->PutPrecision( ( enum PRECISION_TYPE ) m_precision );      // T[`
    
		// 摜̏
		if (( m_condition < 1 ) || ( m_condition > 9 )) {
			MessageBox("摜Ԃ 1`9 ̊ԂŐݒ肵Ă","G[", MB_ICONWARNING | MB_OK);
			return;
		}
		m_FvxCorrelation->PutCondition( m_condition );

		// 臒l
		if (( m_threshold < 10 ) || ( m_threshold > 1000 )) {
			MessageBox("臒l 10`100 ̊Ԃœ͂Ă","G[", MB_ICONWARNING | MB_OK);
			return;
		}
		m_FvxCorrelation->PutScoreThresh( m_threshold );
    
		// r臒l
		if (( m_middlethreshold < 10 ) || ( m_middlethreshold > 1000 ))	{
			MessageBox("r臒l 10`100 ̊Ԃœ͂Ă","G[", MB_ICONWARNING | MB_OK);
			return;
		}
		m_FvxCorrelation->PutScoreThresh2( m_middlethreshold );
    
		// T[`
		m_FvxCorrelation->PutSearchNum( m_searchnum );
    
		// ͈͐ڐGĂ̂o邩
		// ͈͐ڐG
		if ( m_gswndtouch == TRUE )	m_FvxCorrelation->PutWindowTouch( ON );
		else m_FvxCorrelation->PutWindowTouch( OFF );

		// ԌvJn
		m_FvxPerformanceCounter->StartCount();
		// p^[ݒ
		m_FvxCorrelation->SetPattern( m_FvxPattern );
		// T[`s
		m_FvxCorrelation->Execute( m_FvxImageGray, &lngCount );
		// ԌvI
		m_FvxPerformanceCounter->StopCount( &dblTime );
    
		// ͈͂ŕ\
		m_disp->m_FvxDisplayEx->PutPenColor( 0xFF0000 );
		m_disp->m_FvxDisplayEx->DrawData( 0 , m_GSExeRegion );
    
		// T[`ʂԂŕ\
		m_disp->m_FvxDisplayEx->PutPenColor( 0x0000FF );
		m_disp->m_FvxDisplayEx->PutFontColor( 0xFF0000 );

		m_result.Format(" : %fms\r\nT[` : %d\r\nNo      X      Y   score\r\n" , dblTime , lngCount );

		m_FvxCorrelation->GetResult( -1 , pSearchResultGroup );
		m_disp->m_FvxDisplayEx->DrawData( 0, pSearchResultGroup );

		CString str;
		for ( int i = 0 ; i <= pSearchResultGroup->GetCount() - 1 ; i++ ) {
			pPoint->Putx( pSearchResultGroup->Item2(i)->Getx() );
			pPoint->Puty( pSearchResultGroup->Item2(i)->Gety() );
			str.Format("%d", i );
			m_disp->m_FvxDisplayEx->DrawText( 0, pPoint , _bstr_t( str ));
			str.Format("%.3d  %.1f  %.1f   %.1d\r\n", i , pSearchResultGroup->Item2(i)->Getx() , pSearchResultGroup->Item2(i)->Gety() , pSearchResultGroup->Item2(i)->Getscore());
			m_result = m_result + str;
		}
		UpdateData( FALSE );

	} catch (_com_error) {

		long lngErr = 0;
		CString cStr;

		m_FvxCorrelation->GetErrReport( &lngErr );

		switch ( lngErr ) {
			case 0:
				cStr.Format("G[");
				break;
			case 5001:
				cStr.Format("p^݂Ă܂Berr_no = %d", lngErr );
				break;
			case 5005:
				cStr.Format("p[^Ⴂ܂Berr_no = %d", lngErr );
				break;
			case 5006:
				cStr.Format("^Ⴂ܂Berr_no = %d", lngErr );
				break;
			case 5007:
				cStr.Format("p^摜̂߁Ao^ł܂Berr_no = %d", lngErr );
				break;
			case 5008:
				cStr.Format("p^ƃ}XÑTCYvĂ܂Berr_no = %d", lngErr );
				break;
			case 5009:
				cStr.Format("p[^NULLlw肳܂Berr_no = %d", lngErr );
				break;
			case 5010:
				cStr.Format("̊mۂɎs܂Berr_no = %d", lngErr );
				break;
			case 5022:
				cStr.Format("p^w肳Ă܂Berr_no = %d", lngErr );
				break;
			default:
				cStr.Format("sȃG[ err_no = %d", lngErr );
				break;
		}

		MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
		return;
	}
}

void CBlobPatternDlg::OnGsexeregion() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    long lngOK = 0;
    double dblTemp = 0;

    m_FvxROI->SetRectangle( m_GSExeRegion );
    
    // FvxROIgď͈͑I_CAOo܂
    m_FvxROI->PutUsePoint( FALSE );
    m_FvxROI->MakeROIDialog( m_FvxImageGray, &lngOK );
    
    if (( lngOK == 1 ) && ( m_FvxROI->GetCheckRectangle() == 1 )) {

        m_FvxROI->GetRectangle( m_GSExeRegion );
        
        // n_ƏI_tɂȂĂȂ`FbN܂
        // FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
        // tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
        if ( m_GSExeRegion->Getxe()  < m_GSExeRegion->Getxs()) {
            dblTemp = m_GSExeRegion->Getxs();
            m_GSExeRegion->Putxs( m_GSExeRegion->Getxe());
            m_GSExeRegion->Putxe( dblTemp );
		}
		if ( m_GSExeRegion->Getye() < m_GSExeRegion->Getys()) {
            dblTemp = m_BlobExeRegion->Getys();
            m_GSExeRegion->Putys(m_GSExeRegion->Getye());
            m_GSExeRegion->Putye( dblTemp );
		}
	}
		
	DrawExeRegion();

}

BOOL CBlobPatternDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if(pMsg->message == WM_KEYDOWN)
	{
		switch( pMsg->wParam )
		{
			case VK_RETURN:
			case VK_ESCAPE:
				return false;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CBlobPatternDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// DisplayJ
	if ( m_disp!=NULL ) {
		m_disp->DestroyWindow();
		delete m_disp;
		m_disp = NULL;
	}

	// rfIfoCXI[vĂꍇ̓N[Y܂
	if ( m_blnVideoOpened == true ) {
		m_FvxVideo->CloseDevice();	
	}
	
}
